;============================================================================================
; ddwbmp1.asm    DirectX  Load bmp in Window Mode
; GoAsm v 0.53
; Programmed by AsmGges         asmges@aol.com          http://www.chez.com/asmgges/index.htm
;--------------------------------------------------------------------------------------------
; Compile.bat:
; GoAsm ddwbmp1
; GoLink ddwbmp1.obj user32.dll kernel32.dll gdi32.dll ddraw.dll
;============================================================================================

.CONST

ClassName    db ' AsmGges Win32Asm',0
MsgDdError   db 'Direct Draw: failed',0
MsgDataError db 'Opening data file: failed',0
GgesTitle    db '[demo] GoAsm directX Load Bmp WinMode AsmGges Win32 Assembly',0
BmpFile      db 'GoSite.bmp',0

align 4

;============================================================================================

.DATA

DDSD       dd 01Bh dup 0  
DDCOLORKEY dd 2 dup 0
RECT       dd 4 dup 0  
RECT1      dd 4 dup 0  
RECT2      dd 4 dup 0   
RECT3      dd 4 dup 0  
BITMAP     dw 11 dup 0
align 4
WND        dd 10 dup 0
MSG        dd  7 dup 0

DDSPrimary dd ?
DDSBack    dd ?   
lpClipper  dd ?   
DDSFond    dd ?
Object     dd ?  
WinHandle  dd ?
HBarTitle  dd ?
hBitmap    dd ?  
hdcImage   dd ?  
hbmOld     dd ?  
hdc        dd ?  

bActive    db ?
align 4

;============================================================================================

.CODE

START:

    invoke GetModuleHandleA, 0h
    mov [WND+010h],eax

    invoke LoadIconA, [WND+010h], 07F00h
    mov [WND+014h],eax

    invoke LoadCursorA, 0h, 07F00h
    mov [WND+018h],eax

    invoke GetStockObject, 04h
    mov [WND+01Ch],eax

    mov [WND+04h],addr WndProc
    mov [WND+024h],addr ClassName

    invoke RegisterClassA, addr WND

    invoke GetSystemMetrics, 0h
    sub eax,0280h
    shr eax,01h
    mov [RECT2],eax

    mov D[RECT],0h
    mov D[RECT+04h],0h
    mov D[RECT+08h],0280h
    mov D[RECT+0Ch],01E0h
    invoke AdjustWindowRectEx, addr RECT, 04CA0000h , 0h, 0h

    mov eax,[RECT+0Ch]
    sub eax,[RECT+04h]
    sub eax,01E0h
    sub eax,03h
    mov [HBarTitle],eax

    invoke GetSystemMetrics, 01h
    sub eax,01E0h
    sub eax,[HBarTitle]
    shr eax,01h
    mov [RECT2+04h],eax

    mov eax,01E0h
    add eax,[HBarTitle]

    invoke CreateWindowExA, 0h, addr ClassName, addr GgesTitle, 04CA0000h, \
                            [RECT2], [RECT2+04h], 0280h, eax, 0h, 0h, [WND+010h], 0h 
    mov [WinHandle],eax

    invoke ShowWindow, [WinHandle], 0Ah
    invoke UpdateWindow, [WinHandle]

    ;----------------
    ; DirectDraw init
    ;----------------
    invoke DirectDrawCreate, 0h, addr Object, 0h
    or  eax,eax
    jnz >>DdrawError

    ;---------
    ; Win Mode
    ;---------
    push 08h
    push [WinHandle]
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+050h]
    or  eax,eax
    jnz >>DdrawError

    ;------------------------
    ; Create: primary surface
    ;------------------------
    mov D[DDSD],06Ch
    mov D[DDSD+04h],01h
    mov D[DDSD+068h],0200h

    push 0h
    push addr DDSPrimary
    push addr DDSD
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+018h]
    or  eax,eax
    jnz >>DdrawError

    ;---------------------
    ; Create: Back surface
    ;---------------------
    mov D[DDSD],06Ch
    mov D[DDSD+04h],01h+02h+04h
    mov D[DDSD+068h],040h
    mov D[DDSD+0Ch],0280h
    mov eax,01E0h
    add eax,[HBarTitle]
    mov [DDSD+08h],eax

    push 0h
    push addr DDSBack
    push addr DDSD
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+018h]
    or  eax,eax
    jnz >>DdrawError

    ;----------------
    ; Create: clipper
    ;----------------
    push 0h
    push addr lpClipper
    push 0h         
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+010h]
    or  eax,eax
    jnz >>DdrawError

    push [WinHandle]
    push 0h
    mov eax,[lpClipper]
    push eax
    mov eax,[eax]
    call [eax+020h]
    or  eax,eax
    jnz >>DdrawError

    push [lpClipper]
    mov eax,[DDSPrimary]
    push eax
    mov eax,[eax]
    call [eax+070h]
    or  eax,eax
    jnz >>DdrawError

    ;---------------------
    ; Create: Fond surface
    ;---------------------
    mov D[DDSD],06Ch
    mov D[DDSD+04h],01h+02h+04h
    mov D[DDSD+068h],040h+0800h
    mov D[DDSD+0Ch],0280h
    mov D[DDSD+08h],01E0h

    push 0h
    push addr DDSFond
    push addr DDSD
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+018h]
    or  eax,eax
    jnz >>DdrawError

    ;---------
    ; Load bmp
    ;---------
    invoke LoadBmp, addr BmpFile, [DDSFond]
    or  eax,eax
    jnz >>DataError

;============================================================================================

GameLoop:

    ;----------------------
    ; Refresh: Back surface
    ;----------------------
    mov D[RECT],0h
    mov D[RECT+04h],0h
    mov D[RECT+08h],0280h
    mov D[RECT+0Ch],01E0h

    push 0h+010h
    push addr RECT
    push [DDSFond]
    push 0h
    push 0h
    mov eax,[DDSBack]
    push eax
    mov eax,[eax]
    call [eax+01Ch]
    or  eax,eax
    jnz >>DdrawError

;============================================================================================

MessageLoop:

    invoke PeekMessageA, addr MSG, 0h, 0h, 0h, 0h

    cmp eax,0h
    je >L2
        invoke GetMessageA, addr MSG, 0h, 0h, 0h
        cmp eax,0h
        jne >L1
            jmp ExitGame
        L1: 

        invoke TranslateMessage, addr MSG
        invoke DispatchMessageA, addr MSG
        jmp <MessageLoop
    L2: 

    cmp B[bActive],0h
    jne >L1
        invoke WaitMessage
        jmp <MessageLoop
    L1:

    mov eax,[DDSPrimary]
    push eax
    mov eax,[eax]
    call [eax+060h]

    cmp eax,0h
    je >L2
        cmp eax,0887601C2h
        jne >L1
            mov eax,[DDSPrimary]
            push eax
            mov eax,[eax]
            call [eax+06Ch]
            jmp >L2
        L1: 
        jmp ExitGame
    L2: 

    invoke GetWindowRect, [WinHandle], addr RECT2

    ;-----
    ; Flip
    ;-----  
    mov eax,[RECT2]
    add eax,0280h
    mov [RECT2+08h],eax  
    mov eax,[RECT2+04h]
    add eax,[HBarTitle]
    mov [RECT2+04h],eax
    add eax,01E0h
    mov [RECT2+0Ch],eax

    mov D[RECT3+08h],0280h
    mov D[RECT3+0Ch],01E0h

    push 0h
    push 01000000h
    push addr RECT3
    push [DDSBack]
    push addr RECT2
    mov eax,[DDSPrimary]
    push eax
    mov eax,[eax]
    call [eax+014h]
    or  eax,eax
    jnz >DdrawError

    jmp GameLoop

;============================================================================================

DdrawError:
    mov eax,addr MsgDdError
    jmp >Error

DataError:
    mov eax,addr MsgDataError

Error:
    invoke MessageBoxA, [WinHandle], eax, addr ClassName, 0h
    invoke DestroyWindow, [WinHandle]
    invoke PostQuitMessage, 01h
    jmp MessageLoop

ExitGame:
    invoke ExitProcess, [MSG+08h]

;============================================================================================

WndProc FRAME hwnd, uMsg, wParam, lParam

    pushad

    cmp D[uMsg],010h
    jne >L1
        call LibereSurf      
        jmp >L3
    L1:

    cmp D[uMsg],06h
    jne >L1 
        mov eax,[wParam]
        mov [bActive],al
        jmp >L3
    L1:

    cmp D[uMsg],0100h
    jne >L2
        cmp D[wParam],01Bh
        jne >L3
            call LibereSurf    
            jmp >L3
    L2:
  
        popad
        invoke DefWindowProcA, [hwnd], [uMsg], [wParam], [lParam]
        jmp >L1
    L3:

    popad
    mov eax,0h

L1:

    ret
ENDF

;============================================================================================
;-----------------
; Release surfaces
;-----------------
LibereSurf:

    cmp D[Object],0h
    je  L2
        cmp D[DDSFond],0h
        je  >L1
            mov eax,[DDSFond]
            push eax
            mov eax,[eax]
            call [eax+08h]
            mov D[DDSFond],0h
        L1:
         
        cmp D[lpClipper],0h
        je  >L1
            mov eax,[lpClipper]
            push eax
            mov eax,[eax]
            call [eax+08h]
            mov D[lpClipper],0h
        L1:

        cmp D[DDSBack],0h
        je  >L1
            mov eax,[DDSBack]
            push eax
            mov eax,[eax]
            call [eax+08h]
            mov D[DDSBack],0h
        L1:
                   
        cmp D[DDSPrimary],0h
        je  >L1
            mov eax,[DDSPrimary]
            push eax
            mov eax,[eax]
            call [eax+08h] 
            mov D[DDSPrimary],0h
        L1:

        mov eax,[Object]
        push eax
        mov eax,[eax]
        call [eax+08h]
        mov D[Object],0h
    L2:

    invoke PostQuitMessage, 0h

    ret

;============================================================================================

LoadBmp FRAME BmpFilename,DDSSurface

    invoke LoadImageA, 0h, [BmpFilename], 0h, 0h, 0h, 02000h+010h
    or  eax,eax
    jz  >BmpError

    mov [hBitmap],eax

    invoke GetObjectA, [hBitmap], 24, addr BITMAP

    invoke CreateCompatibleDC, 0h
    mov [hdcImage],eax

    invoke SelectObject, [hdcImage], [hBitmap]
    mov [hbmOld],eax

    push addr hdc
    mov eax,[DDSSurface]
    push eax
    mov eax,[eax]
    call [eax+044h]
    or eax,eax
    jnz >L1
        invoke BitBlt, [hdc], 0h, 0h, [BITMAP+04h], [BITMAP+08h], [hdcImage], 0h, 0h, 0CC0020h

        push [hdc]
        mov eax,[DDSSurface]
        push eax
        mov eax,[eax]
        call [eax+068h]
    L1:

    invoke SelectObject, [hdcImage], [hbmOld]
    invoke DeleteObject, [hBitmap]
    invoke DeleteDC, [hdcImage]

    push addr DDCOLORKEY
    push 08h
    mov eax,[DDSSurface]
    push eax
    mov eax,[eax]
    call [eax+074h]
    or  eax,eax
    jz >L2 
    
BmpError:
    mov eax,01h

    L2:

    ret
ENDF

;============================================================================================
;============================================================================================